#ifndef SPI_H
#define SPI_H

#define PIN_CSN      (1<<6)
#define PIN_SCK      (1<<7)
#define PIN_MOSI     (1<<9)
#define PIN_MISO     (1<<8)
#define PIN_IRQ      (1<<11)

#define CE(x)    ((x)?(LPC_GPIO2->FIOSET |= PIN_CE):(LPC_GPIO2->FIOCLR = PIN_CE))
#define CSN(x)   ((x)?(LPC_GPIO2->FIOSET |= PIN_CSN):(LPC_GPIO2->FIOCLR = PIN_CSN))
#define SCK(x)   ((x)?(LPC_GPIO0->FIOSET |= PIN_SCK):(LPC_GPIO0->FIOCLR = PIN_SCK))
#define MOSI(x)  ((x)?(LPC_GPIO0->FIOSET |= PIN_MOSI):(LPC_GPIO0->FIOCLR = PIN_MOSI))
#define MISO(x)  ((x)?(LPC_GPIO0->FIOSET |= PIN_MISO):(LPC_GPIO0->FIOCLR = PIN_MISO))
#define IRQ(x)   ((x)?(LPC_GPIO2->FIOSET |= PIN_IRQ):(LPC_GPIO2->FIOCLR = PIN_IRQ))

/* FT800 low-level functions */
void SPI_init(void);			/* SPI1 init for FT800 */
void SPI_speedup(void);			/* Speed Up SPI1 */
char SPI_send(char data);		/* Send char to SPI1 */
char SPI_rec(char address);		/* Receive char from SPI1 */

void FT_spi_select(void);		/* Select FT800 */
void FT_spi_deselect(void);		/* Deselect FT800 */

#endif
